<template>
    <div>
        <br>
        <div>
            <h5>Neuen Raum hinzufügen</h5>
            <b-button id="show-btn" variant="success" @click="showModal">
                <b-icon icon="plus-square" aria-hidden="true"></b-icon>
            </b-button>

            <b-modal ref="my-modal" @hidden="resetModal" hide-footer>
                <div class="d-block text-center">
                    <form method="post">
                        <b-container fluid>
                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <b-form-input id="input-large" size="lg" placeholder="Raumnamen eingeben"
                                        v-model="raum.name"></b-form-input>
                                </b-col>
                            </b-row>
                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <b-form-input id="input-large" size="lg" placeholder="Raumnummer eingeben"
                                        v-model="raum.nummer"></b-form-input>
                                </b-col>
                            </b-row>
                        </b-container>
                        <div>
                            <b-button block variant="outline-success" @click="postRaum()">
                                Speichern</b-button>
                        </div>
                    </form>
                </div>
            </b-modal>

        </div>

        <div>
            <b-modal ref="my-modal1" @hidden="resetModal" hide-footer>
                <div class="d-block text-center">
                    <form method="post">
                        <b-container fluid>
                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <b-form-input id="input-large" size="lg" placeholder="Raumnamen eingeben"
                                        v-model="editRaeume.name"></b-form-input>
                                </b-col>
                            </b-row>
                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <b-form-input id="input-large" size="lg" placeholder="Raumnummer eingeben"
                                        v-model="editRaeume.nummer"></b-form-input>
                                </b-col>
                            </b-row>
                        </b-container>
                        <div>
                            <b-button block variant="outline-success" @click="putRaum()">
                                Speichern</b-button>
                        </div>
                    </form>
                </div>
            </b-modal>
        </div>

        <br>

        <table class="table">
            <tbody>
                <tr>
                    <th>Name</th>
                    <th>Nummer</th>
                    <th></th>
                    <th></th>
                </tr>
                <tr v-for="raum in raeume" v-bind:key="raum.id">
                    <td>{{ raum.name }}</td>
                    <td>{{ raum.nummer }}</td>                    
                    <td>
                        <b-button id="show-btn" @click="showModal1(raum.raum_id), editRaum(raum)" variant="primary">
                            <b-icon icon="pencil" aria-hidden="true"></b-icon>
                        </b-button>
                    </td>
                    <td>
                        <b-button @click="deleteRaum(raum.raum_id)" variant="danger">
                            <b-icon icon="trash-fill" aria-hidden="true"></b-icon>
                        </b-button>
                    </td>
                </tr>
            </tbody>
        </table>

    </div>
</template>

<script>

export default {
    name: "RaumListe",
    data() {
        return {
            modalShow: false,
            raum: {
                name: '',
                nummer: ''
            },
            editRaeume: {
                name: '',
                nummer: '',
                raum_id: ''
            }
        }
    },
    computed: {
        raeume() {
            return this.$store.state.raeume;
        }
    },
    methods:
    {
        deleteRaum(raum_id) {
            this.$store.dispatch('deleteRaum', raum_id)
        },

        postRaum() {
            this.$store.dispatch('postRaum', this.raum)
            this.hideModal()
        },

        putRaum() {
            this.$store.dispatch('putRaum', this.editRaeume)
            this.hideModal1()
        },

        async editRaum(raum) {
            this.editRaeume.name = raum.name;
            this.editRaeume.nummer = raum.nummer;
            this.editRaeume.raum_id = raum.raum_id;
        },

        resetModal() {
            this.raum.name = '';
            this.raum.nummer = ''
        },

        showModal() {
            this.$refs['my-modal'].show()
        },
        showModal1() {
            this.$refs['my-modal1'].show()
        },
        hideModal() {
            this.$refs['my-modal'].hide()
        },
        hideModal1() {
            this.$refs['my-modal1'].hide()
        }
    },
    mounted() {
        this.$store.dispatch('getAlleRaeume');
    }
}

</script>